.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include comctl32.inc
includelib comctl32.lib

;***************************************************************************************************

NMLVDISPINFO STRUCT
    hdr         NMHDR   <>
    lvitem      LVITEM  <>
NMLVDISPINFO ENDS

;***************************************************************************************************

IDLISTVIEW      equ 1001

WIN_WIDTH       equ 380
WIN_HEIGHT      equ 350

;***************************************************************************************************

.const
AppName         db "VirtualListView",0
LvClass         db "SysListView32",0

LvCols          dd OFFSET col01,250,LVCFMT_LEFT
                dd OFFSET col02,100,LVCFMT_RIGHT
                dd 0
col01           db "Name",0
col02           db "Value",0

fmt_val         db "%d",0

digits          dd OFFSET s0,OFFSET s1,OFFSET s2,OFFSET s3,OFFSET s4,OFFSET s5,OFFSET s6,OFFSET s7,OFFSET s8,OFFSET s9
s0              db "zero",0
s1              db "one",0
s2              db "two",0
s3              db "three",0
s4              db "four",0
s5              db "five",0
s6              db "six",0
s7              db "seven",0
s8              db "eight",0
s9              db "nine",0

.data?
hInstance       HINSTANCE   ?
hListview       HWND        ?

.code
;***************************************************************************************************

ALIGN 4
num_to_name proc num:DWORD,pName:DWORD
    LOCAL dig[16]:CHAR
    push esi
    push edi
    lea esi,[dig]
    mov edi,pName
    invoke wsprintf, esi,ADDR fmt_val,num
  @@:
    movzx eax,BYTE PTR [esi]
    test eax,eax
    jz @F
    sub eax,'0'
    mov edx,[digits+4*eax]
    invoke lstrcpy, edi,edx
    invoke lstrlen, edi
    mov BYTE PTR [edi+eax],' '
    lea edi,[edi+eax+1]
    inc esi
    jmp @B
  @@:
    mov [edi-1],al
    pop edi
    pop esi
    ret
num_to_name endp

ALIGN 4
FillItemInfo proc pLvItem:DWORD
    push edi
    mov edi,pLvItem
    assume edi:PTR LVITEM
    mov ecx,[edi].imask
    test ecx,LVIF_TEXT
    .IF (!ZERO?)
        mov eax,[edi].iItem     ;item row index
        mov edx,[edi].iSubItem  ;item column index
        .IF (edx==0)        ;first column = name
            invoke num_to_name, eax,[edi].pszText
        .ELSEIF (edx==1)    ;second column = value
            invoke wsprintf, [edi].pszText,ADDR fmt_val,eax
        .ENDIF
    .ENDIF

    ;for other data, as required
    ;mov ecx,[edi].imask
    ;test ecx,LVIF_IMAGE
    ;.IF (!ZERO?)
    ;    ;set iImage
    ;.ENDIF

    assume edi:nothing
    pop edi
    ret
FillItemInfo endp

;***************************************************************************************************

ALIGN 4
LvAddColumns proc hLv:HANDLE,pCols:DWORD
    LOCAL col:LV_COLUMN
    push edi
    push esi
    push ebx
    mov edi,pCols
    lea esi,[col]
    assume esi:ptr LV_COLUMN
    xor ebx,ebx
    mov [esi].imask,LVCF_FMT or LVCF_TEXT or LVCF_WIDTH
  @@:
    mov eax,[edi]       ;pLabel
    test eax,eax
    jz @out
    mov edx,[edi+4]     ;colWidth
    mov ecx,[edi+8]     ;colFmt
    mov [esi].pszText,eax
    mov [esi].lx,edx
    mov [esi].fmt,ecx
    invoke SendMessage, hLv,LVM_INSERTCOLUMN,ebx,esi
    add ebx,1
    add edi,(3*4)
    jmp @B
  @out:
    assume esi:nothing
    pop ebx
    pop esi
    pop edi
    ret
LvAddColumns endp

;***************************************************************************************************

ALIGN 4
WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_NOTIFY --------------------------------------------------------------------------------------
    .IF (eax==WM_NOTIFY)
        mov ecx,lParam
        assume ecx:ptr NMHDR
        mov eax,[ecx].hwndFrom
        mov edx,[ecx].code
        .IF (edx==LVN_GETDISPINFO)
            assume ecx:ptr NMLVDISPINFO
            .IF (eax==hListview)
                lea eax,[ecx].lvitem
                invoke FillItemInfo, eax
            .ENDIF
        .ENDIF
        assume ecx:nothing
;-- WM_SETFOCUS ------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_SETFOCUS)
        invoke SetFocus, hListview
;-- WM_SIZE ----------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_SIZE)
        mov eax,lParam
        mov edx,eax
        and eax,0ffffh  ;width
        shr edx,16      ;height
        invoke MoveWindow, hListview,0,0,eax,edx,TRUE
;-- WM_CREATE --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke CreateWindowEx, NULL,ADDR LvClass,NULL,WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_OWNERDATA or LVS_SHOWSELALWAYS,0,0,0,0,hwnd,IDLISTVIEW,hInstance,NULL
        mov hListview,eax
        invoke SendMessage, hListview,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT,LVS_EX_FULLROWSELECT
        invoke LvAddColumns, hListview,ADDR LvCols
        invoke SendMessage, hListview,LVM_SETITEMCOUNT,12345679,LVSICF_NOINVALIDATEALL
;-- WM_DESTROY -------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke PostQuitMessage, NULL
;-- default ----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

ALIGN 4
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL hwnd:HWND
    mov [wc].cbSize,SIZEOF wc
    mov [wc].style,CS_OWNDC
    mov [wc].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [wc].hInstance,eax
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov [wc].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [wc].hCursor,eax
    mov [wc].hbrBackground,COLOR_WINDOW+1
    mov [wc].lpszClassName,OFFSET AppName
    xor eax,eax
    mov [wc].cbClsExtra,eax
    mov [wc].cbWndExtra,eax
    mov [wc].lpszMenuName,eax
    mov [wc].hIconSm,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR AppName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,WIN_WIDTH,WIN_HEIGHT,NULL,NULL,hInstance,NULL
    .IF (eax)
        push ebx
        mov hwnd,eax
        invoke ShowWindow, hwnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hwnd
        lea ebx,[msg]
        assume ebx:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, ebx,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, ebx
            invoke DispatchMessage, ebx
        .ENDW
        mov eax,[ebx].wParam
        assume ebx:nothing
        pop ebx
    .ENDIF
    ret
WinMain endp

;***************************************************************************************************

ALIGN 4
start:
    invoke InitCommonControls
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax
end start

;***************************************************************************************************
